#include <iostream>
#include <unistd.h>
using namespace std;


template <class D> class container {
    public:
        container *proximo;
        D elemento;
};


template <class T, class Container=container<T>>
class deque {
    public:
        void insereInicio(T elem) {
            auto cont = new container<T>();
            cont->elemento = elem;

            if (inicio == nullptr) {    
                fim = cont;           
                cont->proximo = nullptr;
            }
            else 
                cont->proximo = inicio;

            inicio = cont;
        }


        void insereFim(T elem) {
            auto cont = new container<T>();
            cont->elemento = elem;
            cont->proximo = nullptr;

            if (fim == nullptr)
                inicio = cont;
            else 
                fim->proximo = cont;
            
            fim = cont;


        }

        T removeinicio() {
            if (inicio != nullptr) {
                T elemento = inicio->elemento;
                Container *i = inicio;
                if (inicio == fim) { 
                    inicio = nullptr;
                    fim = nullptr;
                }
                else
                    inicio = inicio->proximo;
                delete i;
                return elemento;
            }
            else
                return -1;
        }
        T removeFim() {
            if (fim != nullptr) {
                T elemento = fim->elemento;
                if (inicio == fim) {
                    inicio = nullptr;
                    delete fim;
                    fim = nullptr;
                }
                else {
                    Container *f = fim;
                    Container *novoFim = inicio;
                    while (novoFim->proximo != fim){
                        novoFim = novoFim->proximo;
                    }
                    fim = novoFim;
                    delete f;
                }
                return elemento;
            }
            else
                return -1;
        }
        T bucaInicio() {
            return nullptr;
        }
        T buscaFim() {
            return nullptr;
        }
    private:
        Container *inicio = nullptr;
        Container *fim = nullptr;

};


int main(int argc, char* argv[]) {

    deque<int> meuDeque;

    meuDeque.insereInicio(9);
    meuDeque.insereInicio(3);
    meuDeque.insereInicio(4);
    meuDeque.insereInicio(7);

    auto d = meuDeque.removeFim();
    /*printf ("primeiro %d  ", d);
    d = meuDeque.removeFim();
    printf ("segundo %d  ", d);
    d = meuDeque.removeFim();
    printf ("terceiro %d  ", d);
    d = meuDeque.removeinicio();
    printf ("quarto %d  ", d);
    d = meuDeque.removeinicio();*/

    while (d != -1) {
        printf ("%d  ", d);
        d = meuDeque.removeinicio();

    }

    return 0;

}